package com.its.op.service.its.rse;

import com.its.op.dao.repository.its.rse.TbRseSectTrafRepository;
import com.its.op.dto.its.rse.TbRseSectTrafDto;
import com.its.op.entity.its.rse.TbRseSectTraf;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;
import java.util.NoSuchElementException;
import java.util.Optional;

@Slf4j
@RequiredArgsConstructor
@Service
public class TbRseSectTrafService {

    private final TbRseSectTrafRepository repo;

    // 데이터 1건 조회, 없으면 exception
    private TbRseSectTraf requireOne(Long id) throws NoSuchElementException {
        Optional<TbRseSectTraf> info = this.repo.findById(id);
        if (info.isPresent()) {
            return info.get();
        }
        else {
            throw new NoSuchElementException("데이터가 존재하지 않습니다: " + id);
        }
//        return this.repo.findById(id)
//                .orElseThrow(() -> new NoSuchElementException("데이터가 존재하지 않습니다: " + id));
    }

    // 전체 데이터 조회
    @Transactional(readOnly = true)
    public List<TbRseSectTrafDto> findAll() {
        List<TbRseSectTrafDto> result = new ArrayList<>();
        List<TbRseSectTraf> data = this.repo.findAll();
        for (TbRseSectTraf entity : data) {
            result.add(entity.toDto());
        }
        return result;
    }

}
